/*!
 * JQueryCalendar v1.1.0
 * License: Apache License 2.0
 * Copyright 2014 (C) ITcowork Inc. All Rights Reserved.
 * http://www.itcowork.co.jp/genexus/jqcalendar/
 */
function JQueryCalendar($)
{
	this.DateLang;
	this.TimeLang;
	this.TimeControlType;
	this.Width;
	this.Height;

	this.show = function()
	{
		///UserCodeRegionStart:[show] (do not remove this comment.)

		// Backup this
		var mythis = this;

		// Language Setup
		$(function()
		{
			$.datepicker.setDefaults($.datepicker.regional[mythis.DateLang]);
		});
		(function()
		{
			$.timepicker.setDefaults($.timepicker.regional[mythis.TimeLang]);
		})($);

		$('input[onblur^="gx.date.valid_date"]').each(function(){

			// Get Calendar Icon Id
			var iconId = $('#'+$(this).attr('id') + '+img').attr('id');

			// Calendar Icon Hide
			$('#'+$(this).attr('id') + '+img').css('display','none');

			// Comma Sprit
			var onblurArray = mythis.commaSprit($(this).attr('onblur'));

			if(onblurArray[3] == 0){
				// Date Type
				$('#'+$(this).attr('id')).datepicker({
					showOn: "button",
					showButtonPanel: true,
					dateFormat: mythis.dateFormat(onblurArray[1]),
					onSelect: function(t){
						// If you select
						mythis.focusRefresh(this,t);
					},
					onClose: function(t){
						// If you close
						//mythis.focusRefresh(this,t);
					}
				});

			}else if(onblurArray[3] > 0){

				if(onblurArray[1] == 0){
					// Time Type
					$('#'+$(this).attr('id')).timepicker({
						showOn: "button",
						controlType: mythis.TimeControlType,
						timeFormat: mythis.timeFormat(onblurArray[3]),
						amNames: ['AM', 'A'],
						pmNames: ['PM', 'P'],
						onSelect: function(t){
							// If you select
							mythis.focusRefresh(this,t);
						},
						onClose: function(t){
							// If you close
							mythis.focusRefresh(this,t);
						}
					});
				}else{
					// DateTime Type
					$('#'+$(this).attr('id')).datetimepicker({
						showOn: "button",
						controlType: mythis.TimeControlType,
						dateFormat: mythis.dateFormat(onblurArray[1]),
						timeFormat: mythis.timeFormat(onblurArray[3]),
						amNames: ['AM', 'A'],
						pmNames: ['PM', 'P'],
						onSelect: function(t){
							// If you select
							mythis.focusRefresh(this,t);
							//$(this).datepicker("hide");
						},
						onClose: function(t){
							// If you close
							mythis.focusRefresh(this,t);
						}
					});
				}
			}else{
				//alert("else");
			}

		// Button ID Change
		//$('#'+$(this).attr('id') + '+button').css('display','none');
		//$('#'+$(this).attr('id') + '+button').attr('id', iconId);

		});

		///UserCodeRegionEnd: (do not remove this comment.)
	}
	///UserCodeRegionStart:[User Functions] (do not remove this comment.)

	this.commaSprit = function(str)
	{
		// commaSprit
		var resArray = str.split(",");
		return resArray;
	}


	this.dateFormat = function(num)
	{
		var strFormat;
		var _gxDateFormat = gx.dateFormat;
		_gxDateFormat = _gxDateFormat.replace(/(.)(?=.)/g, "$1/");

		switch (Number(num)) {
			case 0: strFormat = ""; break;
			case 8:
				strFormat = this.setYMDString('y','mm','dd',_gxDateFormat);	// y/mm/dd
				break;
			case 10:
				strFormat = this.setYMDString('yy','mm','dd',_gxDateFormat);	// yy/mm/dd
				break;
			default : strFormat = ""; break;
		}
		return strFormat;
	}

	this.timeFormat = function(num)
	{
		var strFormat;
		var _gxTimeFormat = gx.timeFormat;

		if(_gxTimeFormat == 12) {
			switch (Number(num)) {
				case 2: strFormat = "hh TT"; break;
				case 5: strFormat = "hh:mm TT"; break;
				case 8: strFormat = "hh:mm:ss TT"; break;
				default : strFormat = ""; break;
			}
		}else if(_gxTimeFormat == 24){
			switch (Number(num)) {
				case 2: strFormat = "HH"; break;
				case 5: strFormat = "HH:mm"; break;
				case 8: strFormat = "HH:mm:ss"; break;
				default : strFormat = ""; break;
			}
		}

		return strFormat;
	}

	this.setYMDString = function(y, m, d, format)
	{
		format = format.replace('Y',y);
		format = format.replace('M',m);
		format = format.replace('D',d);
		return format;
	}

	this.focusRefresh = function(inpt,t)
	{
		$('#'+$(inpt).attr('id')).focus();

		// Refresh...
		//gx.evt.execEvt('Refresh.',this);

		// Grid refresh...
		//gx.O.refreshDependantGrids(inpt);

		if(t){
			var FakeCalendar = {
				dateClicked: true,
				date : {
					print : function (str) {return t;}
				},
				callCloseHandler : function(){}
			}

			inpt.value = "";
			gx.fn.datePickerChanged(FakeCalendar,t,inpt);
		}

	}

	// Override Calendar setup function
	if (typeof(Calendar) != "undefined") Calendar.setup = function(a){}

	// Override timepicker log function
	$.timepicker.log = function ()
	{
		if(gx.dbg.enabled){
			window.console && window.console.log.apply(window.console, Array.prototype.slice.call(arguments))
		}
	}

	///UserCodeRegionEnd: (do not remove this comment.):
}
